<?php

require_once("cfg.php");
require_once("func/global_func.php");
require_once("skin/".$CFG['skin']."/skin.php");
require_once("lang/".$CFG['lang'].".php");

timer_start();

$EGN['title'] = '';
$EGN['content'] = '';
$EGN['errors'] = '';
$EGN['adm'] = usertest();

function adm_idx()
{
	global $CFG, $EGN, $LANG;

	if ( isset($_POST['pass']) && $EGN['adm'] != 1 )
	{
		$login = protect(trim($_POST['login']));
		$pass = md5(md5(trim($_POST['pass'])).md5($login));

		if ($login == '')
		{
			$EGN['errors'] .= $LANG['err_loginempty'];
		}
		elseif ( $login != $CFG['adlogin'] )
		{
			$EGN['errors'] .= $LANG['err_loginuncorrect'];
		}

		if ($pass == '')
		{
			$EGN['errors'] .= $LANG['err_passempty'];
		}
		elseif ($pass != $CFG['adpass'])
		{
			$EGN['errors'] .= $LANG['err_passuncorrect'];
		}

		if ($EGN['errors'] == '')
		{
            $_SESSION['adlogin'] = $CFG['adlogin'];
            if( isset($_POST['saveme']) && $_POST['saveme'] == 'on' )
            {
            	setcookie('gblogin', $login, time() + 3600*24*30 );
            	setcookie('gbpass', $pass, time() + 3600*24*30 );
            }
            header("location: ".$CFG['gb_url']."/?".SID);
		}
		else
		{
	        $EGN['content'] = html_log_in( html_msg_error( $EGN['errors'] ) );
	        $EGN['timer'] = timer_stop();
	        print gzip( html_gb_page() );
		}
		exit;
	}
	elseif ($EGN['adm'] == 1)
	{
		$mass = file($CFG['dbname']);
	    $mcount = sizeof($mass);
	    $dbsize = round(filesize($CFG['dbname'])/1024, 2);
	    $gzip = ($CFG['gzip'] == 1)?$LANG['on']:$LANG['off'];
	    $phpver = phpversion();

	    $EGN['title'] = $LANG['mainpage'];
	    $EGN['content'] .= <<<EOF
<h1>{$LANG['information']}</h1><br />
{$LANG['version']} Simple GV GuestBook<br />
{$LANG['version']} PHP: {$phpver}<br />
{$LANG['gzipgrip']}: {$gzip}<br />
{$LANG['usedtheme']}: &laquo;{$CFG['skin']}&raquo;<br />
{$LANG['amountmsg']}: {$mcount}<br />
{$LANG['fnamedatabase']}: &laquo;{$CFG['dbname']}&raquo;<br />
{$LANG['sizedatabase']}: {$dbsize} {$LANG['kb']}<br /><br />
EOF;

	}
	else
	{
		$EGN['content'] = html_log_in('');
		$EGN['timer'] = timer_stop();
		print gzip( html_gb_page() );
		exit;
	}
}

//   
switch(@$_GET['act'])
{
	case 'config':
	include_once("func/adm_config_func.php");
	adm_config();
	break;

	case 'smiles':
	include_once("func/adm_smiles_func.php");
	adm_smiles();
	break;

	case 'ipban':
	include_once("func/adm_ipban_func.php");
	adm_ipban();
	break;

	case 'database':
	include_once("func/adm_database_func.php");
	adm_database();
	break;

	case 'exit':
	setcookie('gblogin', '', time()-1);
	setcookie('gbpass', '', time()-1);
	setcookie('s', '', time()-1, '/');
	session_destroy();
	print html_msg_box(' !', $CFG['gb_url']);
	exit;
	break;

	default: adm_idx();
}

$EGN['timer'] = timer_stop();

//      
print gzip( html_admin_page() );
?>