<?php

function adm_config_rewrite()
{
	global $CFG;

	$data = "<?php\n";
	foreach($CFG as $key => $val )
	{
		$data .= '$CFG["'.$key.'"] = '."'".$val."';\n";
	}
	$data .= "?>";

	@chmod('cfg.php', 0666);
    $fp = fopen('cfg.php', 'w');
    flock($fp, LOCK_EX);
    fwrite($fp, $data);
    flock($fp, LOCK_UN);
    fclose($fp);
    @chmod('cfg.php', 0644);
}

function adm_config_form()
{
	global $CFG, $LANG;

    $lang = "<select name='lang'>";
    $dr = opendir('lang');
    while (false !== ($cf = readdir($dr)))
    {
        if ( @!is_file($cf) && preg_match("#^([a-z0-9]+\.php)$#i", $cf))
        {
        	$lg = substr($cf, 0, -4);
            if($lg == $CFG['lang'])
            {
            	$lang .= "<option value='".$lg."' selected>".$lg."</option>";
            }
            else
            {
            	$lang .= "<option value='".$lg."'>".$lg."</option>";
            }
        }
    }
    closedir($dr);
    $lang .= '</select>';

    $skin = "<select name='skin'>";
    $dr = opendir('skin');
    while (false !== ($cf = readdir($dr)))
    {
        if ( @!is_dir($cf) && is_file('skin/'.$cf.'/skin.php') && preg_match("#^([a-z0-9]+)$#i", $cf))
        {
            if($cf == $CFG['skin'])
            {
            	$skin .= "<option value='".$cf."' selected>".$cf."</option>";
            }
            else
            {
            	$skin .= "<option value='".$cf."'>".$cf."</option>";
            }
        }
    }
    closedir($dr);
    $skin .= '</select>';

    $sel1 = $sel2 = '';
    if($CFG['gzip'] == 1){$sel1 = ' selected';}else{$sel2 = ' selected';}
    $gzip = "<select name='gzip'><option value='1'{$sel1}>{$LANG['toon']}</option><option value='0'{$sel2}>{$LANG['tooff']}</option></select>";

    $sel1 = $sel2 = '';
    if($CFG['capcha'] == 1){$sel1 = ' selected';}else{$sel2 = ' selected';}
    $capcha = "<select name='capcha'><option value='1'{$sel1}>{$LANG['toon']}</option><option value='0'{$sel2}>{$LANG['tooff']}</option></select>";

    $sel1 = $sel2 = '';
    if($CFG['formpos'] == 1){$sel1 = ' selected';}else{$sel2 = ' selected';}
    $formpos = "<select name='formpos'><option value='1'{$sel1}>{$LANG['below']}</option><option value='0'{$sel2}>{$LANG['above']}</option></select>";


    $sel1 = $sel2 = '';
    if($CFG['getmail'] == 1){$sel1 = ' selected';}else{$sel2 = ' selected';}
    $getmail = "<select name='getmail'><option value='1'{$sel1}>{$LANG['tosend']}</option><option value='0'{$sel2}>{$LANG['tonotsend']}</option></select>";

    $sel1 = $sel2 = '';
    if($CFG['htmlanswer'] == 1){$sel1 = ' selected';}else{$sel2 = ' selected';}
    $htmlanswer = "<select name='htmlanswer'><option value='1'{$sel1}>{$LANG['toallow']}</option><option value='0'{$sel2}>{$LANG['toforbid']}</option></select>";

	return <<<EOF
<h1>{$LANG['changeconfig']}</h1><br />
<table width='100%' cellspacing='1' cellpadding='0' border='1'>
<form action='?act=config&make=edit' method='post' name='cfgedit'>
<tr><td class='lcfg'>{$LANG['usedtheme']}:</td><td class='rcfg'>{$skin}</td></tr>
<tr><td class='lcfg'>{$LANG['language']}:</td><td class='rcfg'>{$lang}</td></tr>
<tr><td class='lcfg'>{$LANG['gburl']}:</td><td class='rcfg'><input type='text' name='gb_url' value='{$CFG['gb_url']}' class='cfg' /></td></tr>
<tr><td class='lcfg'>{$LANG['urlforlogo']}:</td><td class='rcfg'><input type='text' name='lg_url' value='{$CFG['lg_url']}' class='cfg' /></td></tr>
<tr><td class='lcfg'>{$LANG['adminmail']}:</td><td class='rcfg'><input type='text' name='admail' value='{$CFG['admail']}' class='cfg' /></td></tr>
<tr><td class='lcfg'>{$LANG['charsetpage']}:</td><td class='rcfg'><input type='text' name='charset' value='{$CFG['charset']}' class='cfg' /></td></tr>
<tr><td class='lcfg'>{$LANG['gzipgrip']}</td><td class='rcfg'>{$gzip}</td></tr>
<tr><td class='lcfg'>{$LANG['msgperpage']}:</td><td class='rcfg'><input type='text' name='mpp' value='{$CFG['mpp']}' class='cfg' /></td></tr>
<tr><td class='lcfg'>{$LANG['smperrow']}:</td><td class='rcfg'><input type='text' name='smpr' value='{$CFG['smpr']}' class='cfg' /></td></tr>
<tr><td class='lcfg'>{$LANG['antispam']}:</td><td class='rcfg'><input type='text' name='stoptime' value='{$CFG['stoptime']}' class='cfg' /></td></tr>
<tr><td class='lcfg'>{$LANG['capcha']}:</td><td class='rcfg'>{$capcha}</td></tr>
<tr><td class='lcfg'>{$LANG['maxsymbinmsg']}:</td><td class='rcfg'><input type='text' name='msg_max' value='{$CFG['msg_max']}' class='cfg' /></td></tr>
<tr><td class='lcfg'>{$LANG['minsymbinmsg']}:</td><td class='rcfg'><input type='text' name='msg_min' value='{$CFG['msg_min']}' class='cfg' /></td></tr>
<tr><td class='lcfg'>{$LANG['maxsminmsg']}:</td><td class='rcfg'><input type='text' name='smpm' value='{$CFG['smpm']}' class='cfg' /></td></tr>
<tr><td class='lcfg'>{$LANG['formplace']}:</td><td class='rcfg'>{$formpos}</td></tr>
<tr><td class='lcfg'>{$LANG['htmlanswer']}:</td><td class='rcfg'>{$htmlanswer}</td></tr>
<tr><td class='lcfg'>{$LANG['getmail']}:</td><td class='rcfg'>{$getmail}</td></tr>
<tr><td class='lcfg'>{$LANG['gbname']}:</td><td class='rcfg'><input type='text' name='title' value='{$CFG['title']}' class='cfg' /></td></tr>
<tr><td class='lcfg'>{$LANG['keywords']}:</td><td class='rcfg'><input type='text' name='keywords' value='{$CFG['keywords']}' class='cfg' /></td></tr>
<tr><td class='lcfg'>{$LANG['description']}:</td><td class='rcfg'><input type='text' name='description' value='{$CFG['description']}' class='cfg' /></td></tr>
<tr><td class='lcfg'>{$LANG['fnamedatabase']}:</td><td class='rcfg'><input type='text' name='dbname' value='{$CFG['dbname']}' class='cfg' /></td></tr>
<tr><td colspan='2' class='lcfg' align='right'><input type='submit' value='{$LANG['toedit']}' class='button' /></td></tr>
</form>
</table>
<br /><br />
<h1>{$LANG['changepass']}</h1><br />
<table width='100%' cellspacing='1' cellpadding='0' border='1'>
<form action='?act=config&make=changepass' method='post' name='changepass'>
<tr><td class='lcfg'>{$LANG['login']}:</td><td class='rcfg'><input type='text' name='login' value='{$CFG['adlogin']}' class='cfg' /></td></tr>
<tr><td class='lcfg'>{$LANG['password']}:</td><td class='rcfg'><input type='password' name='password1' value='' class='cfg' /></td></tr>
<tr><td class='lcfg'>{$LANG['password']} ({$LANG['onceagain']}):</td><td class='rcfg'><input type='password' name='password2' value='' class='cfg' /></td></tr>
<tr><td colspan='2' class='lcfg' align='right'><input type='submit' value='{$LANG['tochange']}' class='button' /></td></tr>
</form>
</table><br />
EOF;
}
function adm_config()
{
	global $CFG, $EGN, $LANG;

	if($EGN['adm'])
	{
		if(isset($_GET['make']) && $_GET['make'] == 'edit')
		{
			if(isset($_POST['skin']) && is_file('skin/'.trim($_POST['skin']).'/skin.php'))
            {
            	$CFG['skin'] = trim($_POST['skin']);
            }

			if(isset($_POST['lang']) && is_file('lang/'.trim($_POST['lang']).'.php'))
            {
            	$CFG['lang'] = trim($_POST['lang']);
            }

			if(isset($_POST['gb_url']) && trim($_POST['gb_url']) != '')
            {
            	$gb_url = protect(trim($_POST['gb_url']));
            	if(substr($gb_url, -1, 1) == '/')$gb_url = substr($gb_url, 0, -1);
            	$CFG['gb_url'] = $gb_url;
            }

			if(isset($_POST['lg_url']))
            {
            	$lg_url = protect(trim($_POST['lg_url']));
            	$lg_url = ($lg_url == '')?$CFG['gb_url']:$lg_url;
            	$CFG['lg_url'] = $lg_url;
            }

            if(isset($_POST['admail']) && trim($_POST['admail']) != '')
            {
            	$CFG['admail'] = protect(trim($_POST['admail']));
            }

            if(isset($_POST['charset']) && trim($_POST['charset']) != '')
            {
            	$CFG['charset'] = protect(trim($_POST['charset']));
            }

            if(isset($_POST['gzip']))
            {
            	$CFG['gzip'] = ( intval($_POST['gzip']) == 1 )?1:0;
            }

            if(isset($_POST['capcha']))
            {
            	$CFG['capcha'] = ( intval($_POST['capcha']) == 1 )?1:0;
            }

            if(isset($_POST['mpp']))
            {
            	$CFG['mpp'] = ( is_numeric($_POST['mpp']) )?intval($_POST['mpp']):$CFG['mpp'];
            }

            if(isset($_POST['smpr']))
            {
            	$CFG['smpr'] = ( is_numeric($_POST['smpr']) )?intval($_POST['smpr']):$CFG['smpr'];
            }

            if(isset($_POST['stoptime']))
            {
            	$CFG['stoptime'] = ( is_numeric($_POST['stoptime']) )?intval($_POST['stoptime']):$CFG['stoptime'];
            }

            if(isset($_POST['msg_max']))
            {
            	$CFG['msg_max'] = ( is_numeric($_POST['msg_max']) )?intval($_POST['msg_max']):$CFG['msg_max'];
            }

            if(isset($_POST['msg_min']))
            {
            	$CFG['msg_min'] = ( is_numeric($_POST['msg_min']) )?intval($_POST['msg_min']):$CFG['msg_min'];
            }

            if(isset($_POST['smpm']))
            {
            	$CFG['smpm'] = ( is_numeric($_POST['smpm']) )?intval($_POST['smpm']):$CFG['smpm'];
            }

            if(isset($_POST['formpos']))
            {
            	$CFG['formpos'] = ( intval($_POST['formpos']) == 1 )?1:0;
            }

            if(isset($_POST['htmlanswer']))
            {
            	$CFG['htmlanswer'] = ( intval($_POST['htmlanswer']) == 1 )?1:0;
            }

            if(isset($_POST['getmail']))
            {
            	$CFG['getmail'] = ( intval($_POST['getmail']) == 1 && $CFG['admail'] != '' )?1:0;
            }

			if(isset($_POST['title']))
            {
            	$CFG['title'] = protect(trim($_POST['title']));
            }

			if(isset($_POST['keywords']))
            {
            	$CFG['keywords'] = protect(trim($_POST['keywords']));
            }

			if(isset($_POST['description']))
            {
            	$CFG['description'] = protect(trim($_POST['description']));
            }

            if(isset($_POST['dbname']) && is_file(trim($_POST['dbname'])) && preg_match("#^([a-z0-9\.]+)$#i", trim($_POST['dbname'])))
            {
            	$CFG['dbname'] = trim($_POST['dbname']);
            }

            adm_config_rewrite();
            print html_msg_box($LANG['msg_cfgchanged'], "?act=config");
            exit;
        }
        elseif(isset($_GET['make']) && $_GET['make'] == 'changepass')
        {
        	$login = protect(trim($_POST['login']));
        	$pass1 = trim($_POST['password1']);
        	$pass2 = trim($_POST['password2']);

			if($login != '')
            {
	            if($pass1 != '' && $pass2 != '')
	            {
	                if($pass1 == $pass2)
	                {
	                	$CFG['adlogin'] = $login;
	                    $CFG['adpass'] = md5(md5($pass1).md5($login));
	                    adm_config_rewrite();
	                    print html_msg_box($LANG['msg_passchanged'], "?act=config");
	                    exit;
	                }
	                else
	                {
	                    $EGN['errors'] .= $LANG['err_passnotident'];
	                }
	            }
	            else
	            {
	                $EGN['errors'] .= $LANG['err_passempty'];
	            }
            }
            else
            {
            	$EGN['errors'] .= $LANG['err_loginempty'];
            }
        }

        if($EGN['errors'] != '')$EGN['errors'] = html_msg_error($EGN['errors']);

        $EGN['title'] = $LANG['config'];
        $EGN['content'] .= $EGN['errors'].adm_config_form();
    }
    else
    {
    	print html_msg_box($LANG['msg_norights'],"index.php?page=1");
    	exit;
    }
}
?>