<?php

function protect($text)
{
	$search = array('"','"', '<','>');
	$replace = array('&quot;','&#39;', '&lt;','&gt;');
	$text = str_replace($search, $replace, $text);
	return $text;
}

function brton($txt)
{
	return str_replace("<br />", "\n", $txt);
}

function timer_start()
{
    global $start_time;
    $start_time = array_sum(explode(' ', microtime()));
}

function timer_stop()
{
    global $start_time;
    return round((array_sum(explode(' ', microtime())) - $start_time),4);
}

function gzip($tpl)
{
	global $CFG;
    if(stristr($_SERVER['HTTP_ACCEPT_ENCODING'], 'gzip') && $CFG['gzip']==1)
    {
    	$tpl = gzencode($tpl);
    	header('Content-encoding: gzip');
    }
    return $tpl;
}

//    email
function sendmail($to, $subject, $text, $from)
{
    global $CFG;
    $headers = "MIME-Version: 1.0\r\n";
    $headers .= "Content-type: text/plain; charset={$CFG['charset']}\r\n";
    $headers .= "From: ".$from." <".$from.">\r\n";
    if(get_magic_quotes_gpc())
    {
    	$subject = stripslashes($subject);
    	$text = stripslashes($text);
    }
    @mail($to, $subject, $text, $headers);
}

function usertest()
{
	global $CFG;

	if( isset($_REQUEST['s']) )
	{
		session_name("s");
		session_start();
        if(isset($_SESSION['adlogin']) && $_SESSION['adlogin'] == $CFG['adlogin'])return 1;
	}
	else
	{
	    if( isset($_COOKIE['gblogin']) && isset($_COOKIE['gbpass']) && $_COOKIE['gblogin'] == $CFG['adlogin'] && $_COOKIE['gbpass'] == $CFG['adpass'])
	    {
	        session_name("s");
	        session_start();
	        $_SESSION['adlogin'] = $CFG['adlogin'];
	        return 1;
	    }
	    session_name("s");
	    session_start();
	    return 0;
	}
}

function gen_pages($num, $p)
{
	global $LANG;

	$pages = '';
    if ($num > 1)
    {
        if($num > 1 && $num < 13 )
        {
        	for ($i = 1; $i <= $num; $i++)
            {
                if ($i == $p) $pages .= "<strong style='color: #ca3201'>[".$i."]</strong>&nbsp;";
                else $pages .= "<a href='?page=".$i."' title='{$LANG['page']} ".$i."'>[".$i."]</a>&nbsp;";
            }
        }
        else
        {
            if($p == 1)
            {
                $pages .= "<b style='color: #ca3201'>[1]</b>&nbsp;";
                for($i=2; $i<13; $i++)$pages .= "<a href='?page=".$i."' title='{$LANG['page']} ".$i."'>[".$i."]</a>&nbsp;";
                $pages .= "<a href='?page=2' title='{$LANG['nextpage']}'>[&raquo;]</a>&nbsp;";
                $pages .= "<a href='?page=".$num."' title='{$LANG['lastpage']}'>[&raquo;&raquo;]</a>";
            }
            elseif($p == $num)
            {
                $pages .= "<a href='?page=1' title='{$LANG['firstpage']}'>[&laquo;&laquo;]</a>&nbsp;";
                $pages .= "<a href='?page=".($num-1)."' title='{$LANG['prevpage']}'>[&laquo;]</a>&nbsp;";
                for ($i = $num - 11; $i < $num; $i++)
                {
                    $pages .= "<a href='?page=".$i."' title='{$LANG['page']} ".$i."'>[".$i."]</a>&nbsp;";
                }
                $pages .= "<b style='color: #ca3201'>[".$num."]</b>";
            }
            else
            {
                if($p>5)$pages .= "<a href='?page=1' title='{$LANG['firstpage']}'>[&laquo;&laquo;]</a>&nbsp;";
                $pages .= "<a href='?page=".($p-1)."' title='{$LANG['prevpage']}'>[&laquo;]</a>&nbsp;";
                for ($i=$p-5, $s=$p+5; $i<=$s; $i++)
                {
                    if($i < 1) continue;
                    if($i > $num) break;
                    if ($i == $p) $pages .= "<b style='color: #ca3201'>[".$i."]</b>&nbsp;";
                    else $pages .= "<a href='?page=".$i."' title='{$LANG['page']} ".$i."'>[".$i."]</a>&nbsp;";
                }
                if($p < $num)$pages .= "<a href='?page=".($p+1)."' title='{$LANG['nextpage']}'>[&raquo;]</a>&nbsp;";
                if($p < $num-5)$pages .= "<a href='?page=".$num."' title='{$LANG['lastpage']}'>[&raquo;&raquo;]</a>";
            }
        }
        return $pages;
     }
     else return '';
}

function smile_unpack()
{
	global $EGN;
    $fp = fopen('smiles.dat',"r");
    $str = fread($fp, filesize('smiles.dat'));
    fclose($fp);
    $EGN['smiles'] = unserialize($str);
}

function smile_table($areaname)
{
    global $CFG, $EGN;;
    $i = 0;
    $text = '';
    foreach($EGN['smiles'] as $smcode => $smfile)
    {
        if ( ($i % $CFG['smpr']) == 0)
        {
        	$text .= "\n<br />\n";
        }
        $text .= "<img src='emoticons/".$smfile."' onclick='addsmile(\"".$smcode."\", \"".$areaname."\")' alt='smile' class='smile' />";
        $i++;
    }
    return $text;
}

function emoticons($text)
{
    global $EGN;
    foreach($EGN['smiles'] as $smcode => $smfile)
    {
        $sm_search[] = $smcode;
        $sm_replace[] = "<img src='emoticons/".$smfile."' alt='".$smcode."' />";
    }
    $text = str_replace($sm_search, $sm_replace, $text);
    return $text;
}

function GetCapchaCode()
{
	global $CFG;

    if($CFG['capcha'])return html_form_capcha(session_id());

    return html_form_ip($_SERVER['REMOTE_ADDR']);
}

//----------------------------------------------------//
//  bbcode
function bbcode($text)
{
	global $LANG;
    $search = array('#\[b\](.*?)\[/b\]#si',
    '#\[i\](.*?)\[/i\]#si',
    '#\[u\](.*?)\[/u\]#si',
    '#\[s\](.*?)\[/s\]#si',
    '#\[sup\](.*?)\[/sup\]#si',
    '#\[sub\](.*?)\[/sub\]#si',
    '#\[indent\](.*?)\[/indent\]#si',
    "#\[url\](\S+?)\[/url\]#is",
    '#\[code\](.*?)\[/code\]#si',
    '#\[quote\](.*?)\[/quote\]#si',
    '#\[left\](.*?)\[/left\]#si',
    '#\[center\](.*?)\[/center\]#si',
    '#\[right\](.*?)\[/right\]#si',
    "#script#si");
    $replace = array('<strong>$1</strong>',
    '<em>$1</em>',
    '<u>$1</u>',
    '<s>$1</s>',
    '<sup>$1</sup>',
    '<sub>$1</sub>',
    '<blockquote>$1</blockquote>',
    "<A href='\\1' target='_blank' class='url'>\\1</A>",
    '<code>$1</code>',
    "<div class='quote'><span class='miniword'>{$LANG['quote']}</span><br />$1</div>",
    "<div align='left'>$1</div>",
    "<div align='center'>$1</div>",
    "<div align='right'>$1</div>",
    'scri<i></i>pt');
    $text = preg_replace($search, $replace, $text);
    return $text;
}
?>