<?php

function adm_database()
{
	global $CFG, $EGN, $LANG;

	if($EGN['adm'])
	{
		if(@$_GET['make'] == 'restore')
		{
			if( is_uploaded_file($_FILES['dbase']['tmp_name']) )
			{
				if( !preg_match("#^(\w+\.(dat|gz))$#", $_FILES['dbase']['name'], $matches) )$EGN['errors'] .= $LANG['err_filenotvalid'];

				if($EGN['errors'] == '')
				{
					if($matches[2] == 'gz')
					{
						$data = implode('', gzfile($_FILES['dbase']['tmp_name']));
					}
					else
					{
						$data = implode('', file($_FILES['dbase']['tmp_name']));
					}
					@chmod($CFG['dbname'], 0666);
	                $fp = fopen($CFG['dbname'], 'a+');
	                flock($fp, LOCK_EX);
	                ftruncate($fp, 0);
	                fwrite($fp, $data);
	                flock($fp, LOCK_UN);
	                fclose($fp);
	                @chmod($CFG['dbname'], 0644);
                    print html_msg_box($LANG['msg_isrestored'], '?act=database');
                    exit;
	        	}
	        }
		}
		elseif(@$_GET['make'] == 'backup')
		{
	        $data = implode('', file($CFG['dbname']));
	        if(!empty($_GET['type']) && $_GET['type'] == 'gz')
	        {
	            $gzdata = gzencode($data, 9);
	            header("Content-type: application/octet-stream");
	            header("Content-length: ".strlen($gzdata));
	            header("Content-Disposition: attachment; filename=\"gbdbase_backup.gz\"");
	            header("Expires: Mon, 31 Jan 2006 05:00:00 GMT");
	            header("Cache-Control: no-cache, must-revalidate");
	            header("Pragma: no-cache");
	            header("Last-Modified: ".gmdate("D, d M Y H:i:s")."GMT");
	            echo $gzdata;
	        }
	        else
	        {
                header("Content-type: application/octet-stream");
                header("Content-length: ".strlen($data));
                header("Content-Disposition: attachment; filename=\"gbdbase_backup.dat\"");
                header("Expires: Mon, 31 Jan 2005 05:00:00 GMT");
                header("Cache-Control: no-cache, must-revalidate");
                header("Pragma: no-cache");
                header("Last-Modified: ".gmdate("D, d M Y H:i:s")."GMT");
                echo $data;
	        }
	        exit;
		}

		if($EGN['errors'] != '')$EGN['errors'] = html_msg_error($EGN['errors']);

	    $EGN['title'] = $LANG['database'];
	    $EGN['content'] .= "<h1>{$LANG['reservecopying']}</h1><br />";
	    $EGN['content'] .= "<strong><a href='?act=database&make=backup'>{$LANG['withoutgrip']}</a> | <a href='?act=database&make=backup&type=gz'>{$LANG['gzipcompress']}</a></strong><br /><br />";
	    $EGN['content'] .= "<h1>{$LANG['restorefromcopy']}</h1><br />";
	    $EGN['content'] .= $EGN['errors']."<table width='100%' cellspacing='5' cellpadding='0' border='0'><form enctype='multipart/form-data' action='admin.php?act=backup&make=restore' method='post'><tr><td><strong>{$LANG['dbfilecopy']}</strong><br /><input type='file' name='dbase' class='file' /><br /><input type='submit' value='{$LANG['torestore']}' class='button' /></td></tr></form></table>";
	    $EGN['content'] .= "<h1>{$LANG['attention']}</h1><br />{$LANG['dbattentext']}";

    }
    else
    {
    	print html_msg_box($LANG['msg_norights'], "index.php?page=1");
    	exit;
    }
}
?>