<?php

function adm_ipban()
{
	global $CFG, $EGN, $LANG;

	if($EGN['adm'])
	{
		if(@$_GET['make'] == 'add')
		{
			if(isset($_POST['ipmask']) )
			{
				$ipmask = trim($_POST['ipmask']);

				if(!preg_match("#^([0-9\*]{1,3}\.[0-9\*]{1,3}\.[0-9\*]{1,3}\.[0-9\*]{1,3})$#", $ipmask))
				{
					$EGN['errors'] .= $LANG['err_ipmasknotvalid'];
				}
				if(substr_count($ipmask, '.') > 3)
				{
					$EGN['errors'] .= $LANG['err_toomuchpoints'];
				}
				else
				{
					str_replace('..','.*.',$ipmask);
				}

				$ipmass = file('ipban.dat');
				$ipcount = sizeof($ipmass);

				if( in_array($ipmask, $ipmass) )$EGN['errors'] .= $LANG['ipmaskalredyis'];

				if($EGN['errors'] == '')
				{
					if($ipcount != 0)$ipmask .= "\n";

					@chmod('ipban.dat', 0666);
	                $fp = fopen('ipban.dat', 'a+');
	                flock($fp, LOCK_EX);
	                $previp = @fread($fp, filesize('ipban.dat'));
	                ftruncate($fp, 0);
	                fwrite($fp, $ipmask);
	                fwrite($fp, $previp);
	                flock($fp, LOCK_UN);
	                fclose($fp);
	                @chmod('ipban.dat', 0644);
	        	}
	        }
		}
		elseif(@$_GET['make'] == 'delete' && isset($_GET['id']) && is_numeric($_GET['id'])  && $_GET['id'] > 0)
		{
			$id = intval($_GET['id']);
            $ipmass = file('ipban.dat');
            $ipcount = sizeof($ipmass);
            $i = 1;
            $data = '';
            foreach($ipmass as $ip)
            {
            	if($i != $id)
            	{
            		$data .= trim($ip);
            		if($i != $ipcount)$data .= "\n";
            	}
            	$i++;
            }
            @chmod('ipban.dat', 0666);
            $fp = fopen('ipban.dat', 'a+');
            flock($fp, LOCK_EX);
            ftruncate($fp, 0);
            fwrite($fp, $data);
            flock($fp, LOCK_UN);
            fclose($fp);
            @chmod('ipban.dat', 0644);
		}

		if($EGN['errors'] != '')$EGN['errors'] = html_msg_error($EGN['errors']);

	    $EGN['title'] = $LANG['ipban'];
	    $EGN['content'] .= "<h1>{$LANG['addipmask']}</h1><br />
{$EGN['errors']}
<table width='100%' cellspacing='0' cellpadding='2'>
<form action='?act=ipban&make=add' method='post'>
<tr><td><strong>{$LANG['ipmask']}:</strong></td><td><input type='text' name='ipmask' /></td><td>{$LANG['example']}: 231.127.9.134</td></tr>
<tr><td></td><td><input type='submit' value='{$LANG['toadd']}' class='button' /></td><td></td></tr>
<tr><td colspan='3' class='important'>
<strong>(!)</strong> {$LANG['imp_ipmask1']}<br />
<strong>(!)</strong> {$LANG['imp_ipmask2']}<br />
<strong>(!)</strong> {$LANG['imp_ipmask3']}<br />
<strong>(!)</strong> {$LANG['imp_ipmask4']}<br />
<strong>(!)</strong> {$LANG['imp_ipmask5']}<br />
<strong>(!)</strong> {$LANG['imp_ipmask6']}</td></tr>
</form>
</table>
<br />
<h1>{$LANG['activeipmask']}</h1><br />
<table width='100%' cellspacing='5' cellpadding='0' border='0'>
<tr><td align='center'><strong>{$LANG['mask']}</strong></td><td align='center'><strong>{$LANG['action']}</strong></td></tr>";
	    $ipmass = file('ipban.dat');
	    $i = 1;
	    foreach($ipmass as $ipmask)
	    {
	    	$EGN['content'] .= "<tr><td align='center'>{$ipmask}</td><td align='center'><a href='?act=ipban&make=delete&id={$i}'>{$LANG['toremove']}</a></td></tr>";
	    	$i++;
	    }
	    $EGN['content'] .= "<tr><td colspan='2' class='important'><strong>(!)</strong> {$LANG['imp_ipmask7']}</td></tr></table>";
    }
    else
    {
    	print html_msg_box($LANG['msg_norights'],"index.php?page=1");
    	exit;
    }
}
?>