<?php

function adm_smiles()
{
	global $CFG, $EGN, $LANG;

	if($EGN['adm'])
	{
		smile_unpack();

		if(@$_GET['make'] == 'add')
		{
			if(isset($_POST['code']) && isset($_POST['file']))
			{
				$code = strtolower(trim($_POST['code']));
				$file = strtolower(trim($_POST['file']));

				if($code == '' || strlen($code) < 3)$EGN['errors'] .= $LANG['err_smcodeshort'];
				if($file == '' || strlen($file) < 5)$EGN['errors'] .= $LANG['err_smfnameshort'];
				if(strstr($code, "'"))$EGN['errors'] .= sprintf($LANG['err_smcodenotvalid'], "&#39;");
				if(strstr($code, '"'))$EGN['errors'] .= sprintf($LANG['err_smcodenotvalid'], "&quot;");
				if(strstr($code, '|'))$EGN['errors'] .= sprintf($LANG['err_smcodenotvalid'], "|");
				if(strstr($code, '&'))$EGN['errors'] .= sprintf($LANG['err_smcodenotvalid'], "&amp;");
				if(strstr($code, '>'))$EGN['errors'] .= sprintf($LANG['err_smcodenotvalid'], "&gt;");
				if(strstr($code, '<'))$EGN['errors'] .= sprintf($LANG['err_smcodenotvalid'], "&lt;");
				if(!preg_match("#^([a-z_0-9]+\.(gif|jpg|png|jpeg))$#", $file) || !is_file('emoticons/'.$file))$EGN['errors'] .= $LANG['err_smfnamenotvalid'];
				if(in_array($code, $EGN['smiles']))$EGN['errors'] .= $LANG['err_smcodealredyis'];
				if(in_array($file, $EGN['smiles']))$EGN['errors'] .= $LANG['err_smfnamealredyis'];

				if($EGN['errors'] == '')
				{
                    $data = array();
                    $data[$code] = $file;
                    foreach($EGN['smiles'] as $key => $val)
                    {
                    	$data[$key] = $val;
                    }
                    @chmod('smiles.dat', 0666);
	                $fp = fopen('smiles.dat', 'a+') or die('    smiles.dat :(');
	                flock($fp, LOCK_EX);
	                ftruncate($fp, 0);
	                fwrite($fp, serialize($data));
	                flock($fp, LOCK_UN);
	                fclose($fp);
	                @chmod('smiles.dat', 0644);
                    print html_msg_box($LANG['msg_smileisadded'], '?act=smiles');
                    exit;
	        	}
	        }
		}
		elseif(@$_GET['make'] == 'moveup' && isset($_GET['id']) && is_numeric($_GET['id']) && intval($_GET['id']) != 1)
		{
			$id = intval($_GET['id']);
            $data = array();
            $i = 1;
            foreach($EGN['smiles'] as $smcode => $smfile)
            {
            	if($i == $id-1)
            	{
                	$tmp_code = $smcode;
                	$tmp_file = $smfile;
            	}
                elseif($i == $id)
                {
            		$data[$smcode] = $smfile;
            		$data[$tmp_code] = $tmp_file;
                }
                else
                {
                	$data[$smcode] = $smfile;
                }
                $i++;
            }
            @chmod('smiles.dat', 0666);
            $fp = fopen('smiles.dat', 'a+');
            flock($fp, LOCK_EX);
            ftruncate($fp, 0);
            fwrite($fp, serialize($data));
            flock($fp, LOCK_UN);
            fclose($fp);
            @chmod('smiles.dat', 0644);
            smile_unpack();
		}
		elseif(@$_GET['make'] == 'movedown' && isset($_GET['id']) && is_numeric($_GET['id']))
		{
			$id = intval($_GET['id']);
            $data = array();
            $i = 1;
            foreach($EGN['smiles'] as $smcode => $smfile)
            {
            	if($i == $id+1)
            	{
            		$data[$smcode] = $smfile;
            		$data[$tmp_code] = $tmp_file;
            	}
                elseif($i == $id)
                {
                	$tmp_code = $smcode;
                	$tmp_file = $smfile;
                }
                else
                {
                	$data[$smcode] = $smfile;
                }
                $i++;
            }
            @chmod('smiles.dat', 0666);
            $fp = fopen('smiles.dat', 'a+');
            flock($fp, LOCK_EX);
            ftruncate($fp, 0);
            fwrite($fp, serialize($data));
            flock($fp, LOCK_UN);
            fclose($fp);
            @chmod('smiles.dat', 0644);
            smile_unpack();
		}
		elseif(@$_GET['make'] == 'delete' && isset($_GET['id']) && is_numeric($_GET['id']))
		{
			$id = intval($_GET['id']);
            $data = array();
            $i = 1;
            foreach($EGN['smiles'] as $smcode => $smfile)
            {
                if($i != $id)$data[$smcode] = $smfile;
                $i++;
            }
            @chmod('smiles.dat', 0666);
            $fp = fopen('smiles.dat', 'a+');
            flock($fp, LOCK_EX);
            ftruncate($fp, 0);
            fwrite($fp, serialize($data));
            flock($fp, LOCK_UN);
            fclose($fp);
            @chmod('smiles.dat', 0644);
            print html_msg_box($LANG['msg_smileisremoved'], '?act=smiles');
            exit;
		}

		if($EGN['errors'] != '')$EGN['errors'] = html_msg_error($EGN['errors']);

	    $EGN['title'] = $LANG['smiles'];
	    $EGN['content'] .= "<h1>{$LANG['addsmile']}</h1><br />
{$EGN['errors']}<table width='100%' cellspacing='0' cellpadding='2'>
<form action='?act=smiles&make=add' method='post'>
<tr><td><strong>{$LANG['smilecode']}:</strong></td><td><input type='text' name='code' /></td><td>{$LANG['example']}: *down*</td></tr>
<tr><td><strong>{$LANG['smilefile']}:</strong></td><td><input type='text' name='file' /></td><td>{$LANG['example']}: downsmile.gif</td></tr>
<tr><td></td><td><input type='submit' value='{$LANG['toadd']}' class='button' /></td><td></td></tr>
<tr><td colspan='3' class='important'><strong>(!)</strong> {$LANG['imp_smfileinfolder']}<br />
<strong>(!)</strong> {$LANG['imp_smnotvalidsymbol']}<br />
<strong>(!)</strong> {$LANG['imp_smfileformat']}</td></tr>
</form>
</table><br />
<h1>{$LANG['smiletable']}</h1><br />";
	    $EGN['content'] .= "<table width='100%' cellspacing='5' cellpadding='0' border='0'>";
	    $EGN['content'] .= "<tr><td align='center'><strong>{$LANG['smile']}</strong></td><td align='center'><strong>{$LANG['smilefile']}</strong></td><td align='center'><strong>{$LANG['smilecode']}</strong></td><td align='center'><strong>{$LANG['action']}</strong></td></tr>";
	    $i = 1;
	    $menu = '';
	    $smcount = sizeof($EGN['smiles']);
	    foreach($EGN['smiles'] as $smcode => $smfile)
	    {
	    	if($i != 1)$menu .= "<a href='?act=smiles&make=moveup&id={$i}'>{$LANG['up']}</a> | ";
	    	if($i != $smcount)$menu .= "<a href='?act=smiles&make=movedown&id={$i}'>{$LANG['down']}</a> | ";
	    	$menu .= "<a href='?act=smiles&make=delete&id={$i}'>{$LANG['toremove']}</a>";
	    	$EGN['content'] .= "<tr><td align='center'><img src='emoticons/{$smfile}' /></td><td align='center'>{$smfile}</td><td align='center'>{$smcode}</td><td align='center'>{$menu}</td></tr>";
	    	$i++;
	    	$menu = '';
	    }
	    $EGN['content'] .= "<tr><td colspan='4' class='important'><strong>(!)</strong> {$LANG['imp_smnotdel']}</td></tr></table>";
    }
    else
    {
    	print html_msg_box($LANG['msg_norights'], "index.php?page=1");
    	exit;
    }
}
?>